Summary:	Transparent low-overhead system-wide profiler
Name:		oprofile
Version:	0.9.9
Release:	%mkrel 3
Group:		Development/Other
License:	GPLv2+
URL:		http://oprofile.sourceforge.net/
Source0:	http://prdownloads.sourceforge.net/%name/%name-%version.tar.gz
# Use -module -avoid-version for agents:
Patch0:		oprofile-agents-ldflags.patch
# P1-P4 From upstrem git
# (wally) I was lazy to rediff patches so added a bunch of patches to get P4 apply cleanly
Patch1:		0001-configure-error-message-for-missing-libpfm-is-not-informative-enough.patch
Patch2:		0002-Enable-oprofile-for-new-ppc64le-architecture.patch
Patch3:		0003-Tidy-powerpc64-bfd-target-check.patch
Patch4:		0004-configure-fix-test-for-synth-check-with-GCC-4.9.0.patch
Source11:	%name-16.png
Source12:	%name-32.png
Source13:	%name-48.png
BuildRequires:	binutils-devel
BuildRequires:	qt4-devel
BuildRequires:	libpopt-devel
BuildRequires:	gettext-devel
%ifnarch %arm %mips
BuildRequires:	java-devel
BuildRequires:	javapackages-tools
%endif

%description
OProfile is a system-wide profiler for Linux systems, capable of
profiling all running code at low overhead. OProfile is released
under the GNU GPL.

It consists of a kernel driver and a daemon for collecting sample
data, and several post-profiling tools for turning data into
information.

OProfile leverages the hardware performance counters of the CPU to
enable profiling of a wide variety of interesting statistics, which
can also be used for basic time-spent profiling. All code is
profiled: hardware and software interrupt handlers, kernel modules,
the kernel, shared libraries, and applications.

%package	gui
Summary:	GUI for starting the OProfile profiler
Group:		Development/Other
Requires:	usermode usermode-consoleonly
Requires:	%{name} = %{version}

%description gui
OProfile is a system-wide profiler for Linux systems, capable of
profiling all running code at low overhead. OProfile is released
under the GNU GPL.

This package provides a convenient QT GUI for starting the
profiler.

%package	jit
Summary:	Libraries for profiling Java and other JIT compiled code
Group:		Development/Other

%description	jit
Libraries needed for profiling Java and other JIT compiled code.
For profiling Java code, you need to load
%{_libdir}/oprofile/libjvmti_oprofile.so
into the JVM as per the OProfile documentation.

%package	devel
Summary:	Development files for developing OProfile JIT agents
Group:		Development/Other
Requires:	%{name}-jit = %{version}

%description	devel
Header and development library symlink for libopagent, required for
compiling additional OProfile JIT agents.

%prep
%setup -q
%apply_patches

%build
export QTDIR=%{qt4dir}
# fixes build
touch NEWS AUTHORS INSTALL ChangeLog # strange, autoreconf does not create these
autoreconf -if
%configure2_5x	--with-kernel-support \
		--with-java=%{java_home} \
		--enable-gui=qt4
%make

%install
%makeinstall_std
rm -f %{buildroot}%{_datadir}/doc/%{name}/*.html

# root dialog
install -d -m755 %{buildroot}%{_sbindir}
mv %{buildroot}%{_bindir}/oprof_start %{buildroot}%{_sbindir}/oprof_start
ln -s consolehelper %{buildroot}%{_bindir}/oprof_start

install -d -m755 %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/mageia-%{name}.desktop <<EOF
[Desktop Entry]
Name=OProfile starter
Comment=Start OProfile profiler
Exec=%{_bindir}/oprof_start
Icon=%{name}
Terminal=false
Type=Application
Categories=Development;Profiling;Qt;
EOF

install -m644 %{SOURCE11} -D %{buildroot}%{_iconsdir}/hicolor/16x16/apps/%{name}.png
install -m644 %{SOURCE12} -D %{buildroot}%{_iconsdir}/hicolor/32x32/apps/%{name}.png
install -m644 %{SOURCE13} -D %{buildroot}%{_iconsdir}/hicolor/48x48/apps/%{name}.png

rm %{buildroot}%{_libdir}/oprofile/*a

%pre jit
%_pre_useradd oprofile "%{_var}/lib/oprofile" /bin/nologin

%postun jit
%_postun_userdel oprofile

%files
%doc README TODO COPYING ChangeLog* doc/*.html
%{_bindir}/ocount
%{_bindir}/op-check-perfevents
%{_bindir}/opannotate
%{_bindir}/oparchive
%{_bindir}/opcontrol
%{_bindir}/operf
%{_bindir}/opgprof
%{_bindir}/ophelp
%{_bindir}/opreport
%{_bindir}/oprofiled
%{_bindir}/opimport
%{_bindir}/opjitconv
%{_datadir}/%{name}
%{_mandir}/man1/o*

%files gui
%doc COPYING
%{_bindir}/oprof_start
%{_sbindir}/oprof_start
%{_datadir}/applications/mageia-*.desktop
%{_iconsdir}/hicolor/*/apps/%{name}.png

%files jit
%dir %{_libdir}/oprofile
%ifnarch %arm %mips
%{_libdir}/oprofile/libjvmti_oprofile.so
%endif
%{_libdir}/oprofile/libopagent.so.*

%files devel
%{_includedir}/opagent.h
%{_libdir}/oprofile/libopagent.so





%changelog
* Wed Oct 15 2014 umeabot <umeabot> 0.9.9-3.mga5
+ Revision: 740105
- Second Mageia 5 Mass Rebuild

* Tue Sep 16 2014 umeabot <umeabot> 0.9.9-2.mga5
+ Revision: 683263
- Mageia 5 Mass Rebuild

* Sat Sep 06 2014 wally <wally> 0.9.9-1.mga5
+ Revision: 672708
- new version 0.9.9
- add patches from upstream to fix build with gcc4.9
- drop unneeded automake patch

* Fri Oct 18 2013 umeabot <umeabot> 0.9.8-6.mga4
+ Revision: 522452
- Mageia 4 Mass Rebuild

* Fri Oct 18 2013 luigiwalser <luigiwalser> 0.9.8-5.mga4
+ Revision: 506613
- update java BRs

* Sat Mar 09 2013 rtp <rtp> 0.9.8-4.mga3
+ Revision: 401980
- disable java support on arm/mips

* Sun Jan 13 2013 umeabot <umeabot> 0.9.8-3.mga3
+ Revision: 362183
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Jan 09 2013 cjw <cjw> 0.9.8-2.mga3
+ Revision: 343420
- patch3: fix build with automake 1.13

* Thu Dec 27 2012 wally <wally> 0.9.8-1.mga3
+ Revision: 335727
- new version 0.9.8
- clean .spec a bit

* Thu Nov 03 2011 anssi <anssi> 0.9.7-1.mga2
+ Revision: 162466
- new version
- fix license tag
- drop qt4 patch, applied upstream

* Sat Jan 15 2011 pterjan <pterjan> 0.9.6-3.mga1
+ Revision: 18098
- Build with qt4 (from a patch in SF tracker)

  + ahmad <ahmad>
    - drop unneeded/old scriptlets
    - rename the .desktop file to mageia-*
    - imported package oprofile


* Fri Dec 03 2010 Oden Eriksson <oeriksson@mandriva.com> 0.9.6-2mdv2011.0
+ Revision: 607024
- rebuild

* Wed Nov 25 2009 Per Øyvind Karlsen <peroyvind@mandriva.org> 0.9.6-1mdv2010.1
+ Revision: 469866
- new release: 0.9.6
- drop patches merged upstream (P0 & P1)

* Mon Jul 13 2009 Anssi Hannula <anssi@mandriva.org> 0.9.4-1mdv2010.0
+ Revision: 395412
- new version 0.9.4
- introduce oprofile-jit and oprofile-devel
- fix missing mode argument (mode-argument.patch from CVS)
- fix build on call to basename() (basename.patch from fedora)
- add module ldflags to JIT agents (agents-ldflags.patch)

* Wed Feb 11 2009 Thierry Vignaud <tv@mandriva.org> 0.9.3-8mdv2009.1
+ Revision: 339467
- rebuild for new binutils

* Tue Aug 19 2008 Funda Wang <fwang@mandriva.org> 0.9.3-7mdv2009.0
+ Revision: 273979
- fix bug in specfile
- rebuild

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Tue Jun 10 2008 Thierry Vignaud <tv@mandriva.org> 0.9.3-6mdv2009.0
+ Revision: 217466
- patch 0: fix build with gcc-4.3
- rebuild

* Fri Feb 01 2008 Thierry Vignaud <tv@mandriva.org> 0.9.3-4mdv2008.1
+ Revision: 161064
- rebuild for new libbfd

* Sat Jan 26 2008 Anssi Hannula <anssi@mandriva.org> 0.9.3-3mdv2008.1
+ Revision: 158297
- rebuild for new binutils

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request
    - kill desktop-file-validate's 'warning: key "Encoding" in group "Desktop Entry" is deprecated'

* Tue Jul 17 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.9.3-2mdv2008.0
+ Revision: 52919
- put icon into the right dir (Anssi)

* Tue Jul 17 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.9.3-1mdv2008.0
+ Revision: 52852
- new version
- fdo icons
- adjust desktop file

* Sat Jun 09 2007 Anssi Hannula <anssi@mandriva.org> 0.9.2-5mdv2008.0
+ Revision: 37624
- rebuild for new binutils


* Fri Jan 19 2007 Anssi Hannula <anssi@mandriva.org> 0.9.2-4mdv2007.0
+ Revision: 110661
- rebuild for new gettext

* Thu Jan 11 2007 Anssi Hannula <anssi@mandriva.org> 0.9.2-3mdv2007.1
+ Revision: 107663
- rebuild for new binutils

* Fri Jan 05 2007 Anssi Hannula <anssi@mandriva.org> 0.9.2-2mdv2007.1
+ Revision: 104549
- rebuild for new binutils

* Sun Oct 29 2006 Anssi Hannula <anssi@mandriva.org> 0.9.2-1mdv2007.1
+ Revision: 73619
- 0.9.2
- drop patch0, fixed upstream
- Import oprofile

* Sun Jul 23 2006 Anssi Hannula <anssi@mandriva.org> 0.9.1-6mdv2007.0
- rebuild for new binutils
- xdg menu

* Sat May 27 2006 Anssi Hannula <anssi@mandriva.org> 0.9.1-5mdv2007.0
- patch0: fix build with gcc4.1

* Sat May 27 2006 Anssi Hannula <anssi@mandriva.org> 0.9.1-4mdv2007.0
- rebuild for new binutils on x86_64

* Sat Mar 18 2006 Anssi Hannula <anssi@mandriva.org> 0.9.1-3mdk
- rebuild

* Tue Jan 17 2006 Anssi Hannula <anssi@mandriva.org> 0.9.1-2mdk
- fix BuildRequires

* Sun Jan 15 2006 Anssi Hannula <anssi@mandriva.org> 0.9.1-1mdk
- initial Mandriva release

